"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const vcms_1 = require("../vcms");
class Role extends vcms_1.CreamModel {
    constructor(name) {
        super();
        this.name = name;
    }
}
Role.tableName = 'roles';
Role.relationMappings = {
    users: {
        relation: vcms_1.CreamModel.ManyToManyRelation,
        modelClass: `${__dirname}/User`,
        join: {
            from: 'roles.id',
            through: { from: 'users_roles.role_id', to: 'users_roles.user_id' },
            to: 'users.id'
        }
    }
};
Role.jsonSchema = {
    type: 'object',
    required: ['name'],
    properties: { id: { type: 'integer' }, name: { type: 'string' } }
};
Role.get = (id, eager = '') => __awaiter(this, void 0, void 0, function* () {
    return yield Role.query().findById(id).eager(eager);
});
exports.default = Role;
//# sourceMappingURL=Role.js.map