import { CreamModel, RelationMappings } from '../vcms';
import Role from './Role';
declare class User extends CreamModel {
    id: number;
    username: string;
    firstname: string;
    lastname: string;
    email: string;
    password: string;
    logged: boolean;
    roles?: Role[];
    static tableName: string;
    static relationMappings: RelationMappings;
    static jsonSchema: {
        type: string;
        required: string[];
        properties: {
            id: {
                type: string;
            };
            username: {
                type: string;
            };
            firstname: {
                type: string;
            };
            lastname: {
                type: string;
            };
            email: {
                type: string;
            };
            password: {
                type: string;
            };
        };
    };
    verifyExistence(): Promise<boolean>;
    hasRole(role: string): Promise<boolean>;
    static get: (id: number, eager?: string) => Promise<User>;
    static getByUsername: (username: string, eager?: string) => Promise<User>;
}
export default User;
